/* ***** BEGIN LICENSE BLOCK *****
 
 
 Copyright 2012 Adam Skillen (a_skil(at)encs.concordia.ca), Mohammad Mannan (mmannan(at)encs.concordia.ca)
 
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.  Redistributions in
 * binary form must reproduce the above copyright notice, this list of
 * conditions and the following disclaimer in the documentation and/or other
 * materials provided with the distribution.  Neither the name of Carleton
 * University nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written
 * permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * ***** END LICENSE BLOCK ***** */

  Components.utils.import("resource://myphrase/common.js");
 
/**
 * MyphraseCCSLOptions namespace.
 */
if ("undefined" == typeof(MyphraseCCSLOptions)) {
  var MyphraseCCSLOptions = {};
};


MyphraseCCSLOptions.BrowserOverlay = {
  prefs: null,
  defaultPassLen: 12,
  defaultMasterLen: 8,
  defaultDictSize: 4096,
  defaultwordLength: 14,
  //defaultHashCount: 4096,
  
  onLoad: function() {
	  this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
	  .getService(Components.interfaces.nsIPrefService)
	  .getBranch("extensions.myphrase.");
	  
	  document.getElementById("dictionaryPath").value = this.prefs.getCharPref("pathToDict");
	  //document.getElementById("specialChars").checked = this.prefs.getBoolPref("specialCharsPref");
	  document.getElementById("masterLength").value = this.prefs.getIntPref("masterLengthPref");
	  //document.getElementById("passLength").value = this.prefs.getIntPref("passLengthPref");
	  document.getElementById("dictSize").value = this.prefs.getIntPref("dictSizePref");
	  document.getElementById("wordLength").value = this.prefs.getIntPref("wordLengthPref");
	  //document.getElementById("removeCommon").checked = this.prefs.getBoolPref("removeCommon");

// var removeCommon = this.prefs.getBoolPref("removeCommon");

	  document.getElementById("homepage").focus();
	  
	  // set radio button
	if (this.prefs.getCharPref("pathToDict") == MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/hg-wells_dictionary.txt"))
		document.getElementById("rdoDict").selectedIndex = 0;
	else if (this.prefs.getCharPref("pathToDict") == MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/dickens_dictionary.txt"))
		document.getElementById("rdoDict").selectedIndex = 1;
	else if (this.prefs.getCharPref("pathToDict") == MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/twain_dictionary.txt"))
		document.getElementById("rdoDict").selectedIndex = 3;
	else if (this.prefs.getCharPref("pathToDict") == MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/shakespeare_dictionary.txt"))
		document.getElementById("rdoDict").selectedIndex = 4;
	else
		document.getElementById("rdoDict").selectedIndex = 2;
	  
	  
  },

  custDict: function() {
	var retVal = {path: ""};
	
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]  
                        .getService(Components.interfaces.nsIPromptService);  
  
	var result = prompts.confirm(null, "Save Settings?", "Would you like to save your current settings before proceeding?");

		if (result)
			MyphraseCCSLOptions.BrowserOverlay.saveOptions();
	
	window.openDialog('chrome://myphrase/content/genDict.xul', 
					'Create Custom Dictionary', 'chrome,modal,centerscreen,resizable',
					retVal);
	
	if (retVal.path != null && retVal.path != "") {
		document.getElementById("rdoDict").selectedIndex = 2;
		document.getElementById("dictionaryPath").value = retVal.path;
	}

  },

  defDict1: function() {
	var dictPath = MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/hg-wells_dictionary.txt");
	// this.prefs.setCharPref("pathToDict", dictPath);
	document.getElementById("dictionaryPath").value = dictPath;
  },
  
  defDict2: function() {
  	var dictPath = MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/dickens_dictionary.txt");
	// this.prefs.setCharPref("pathToDict", dictPath);
	document.getElementById("dictionaryPath").value = dictPath;
  },
  
  defDict3: function() {
  	var dictPath = MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/twain_dictionary.txt");
	// this.prefs.setCharPref("pathToDict", dictPath);
		document.getElementById("dictionaryPath").value = dictPath;
  },
  
  defDict4: function() {
  	var dictPath = MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/shakespeare_dictionary.txt");
	// this.prefs.setCharPref("pathToDict", dictPath);
		document.getElementById("dictionaryPath").value = dictPath;
  },
  
  
  onInputDictSize: function() {
  	defaultDictSize = this.prefs.getIntPref("dictSizePref");
  },
  
  onInputWordLen: function() {
  	defaultwordLength = this.prefs.getIntPref("wordLengthPref");
  },
 /* 
  onInputHashCount: function() {
  	defaultHashCount = this.prefs.getIntPref("hashCountPref");
  },
  */
  onInputPassLen: function() {
  	defaultPassLen = this.prefs.getIntPref("passLengthPref");
  },
  
  onInputMasterLen: function() {
  	defaultMasterLen = this.prefs.getIntPref("masterLengthPref");
  },

  saveOptions: function() {
	this.prefs.setCharPref("pathToDict", document.getElementById("dictionaryPath").value);
	//this.prefs.setBoolPref("specialCharsPref", document.getElementById("specialChars").checked);
	//this.prefs.setBoolPref("removeCommon", document.getElementById("removeCommon").checked);
	//this.prefs.setIntPref("passLengthPref", document.getElementById("passLength").value);
	this.prefs.setIntPref("masterLengthPref", document.getElementById("masterLength").value);
	this.prefs.setIntPref("wordLengthPref", document.getElementById("wordLength").value);
	this.prefs.setIntPref("dictSizePref", document.getElementById("dictSize").value);
  
  return true;
 },

 restoreDefaults: function() {
   document.getElementById("masterLength").value = 8;
   //document.getElementById("passLength").value = 12;
   document.getElementById("dictSize").value = 4096;
   document.getElementById("wordLength").value = 14;
   //document.getElementById("hashCount").value = 4096;
   //document.getElementById("specialChars").checked = false;
  // document.getElementById("removeCommon").checked = true;
   document.getElementById("rdoDict").selectedIndex = 0;
   document.getElementById("dictionaryPath").value = 
		MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/hg-wells_dictionary.txt");
 },
 
 pickDictFile: function() {
	var defaultDirFile = "file://" + MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/");
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);		  
	var url = ios.newURI(defaultDirFile, null, null);
	var defaultDirFile = url.QueryInterface(Components.interfaces.nsIFileURL).file;

	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
				.createInstance(nsIFilePicker);
				
	fp.init(window, "Select a File", nsIFilePicker.modeOpen);
	fp.displayDirectory = defaultDirFile;
	fp.appendFilters(nsIFilePicker.filterText);
	fp.appendFilters(nsIFilePicker.filterAll);

	var res = fp.show();

	if (res == nsIFilePicker.returnOK)
	{
	  //this.prefs.setCharPref("pathToDict", fp.file.path);
	  document.getElementById("dictionaryPath").value = fp.file.path;
	  document.getElementById("rdoDict").selectedIndex = 2;
	}
 },
 
};    

window.addEventListener("load", function(e) { MyphraseCCSLOptions.BrowserOverlay.onLoad(e); }, false);
