/* ***** BEGIN LICENSE BLOCK *****
 
 
 Copyright 2012 Adam Skillen (a_skil(at)encs.concordia.ca), Mohammad Mannan (mmannan(at)encs.concordia.ca)
 
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.  Redistributions in
 * binary form must reproduce the above copyright notice, this list of
 * conditions and the following disclaimer in the documentation and/or other
 * materials provided with the distribution.  Neither the name of Carleton
 * University nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written
 * permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * ***** END LICENSE BLOCK ***** */

 /**
  * 09-MAY-12
  * 	TODO:  0
  * 	FIXME: 0
  * 	NOTE:  1
  */
 
Components.utils.import("resource://myphrase/common.js");
Components.utils.import("resource://myphrase/sha1.js");
Components.utils.import("resource://myphrase/gen_pwdhash.js");

/**
 * MyphraseCCSLChrome namespace.
 */
if ("undefined" == typeof(MyphraseCCSLChrome)) {
  var MyphraseCCSLChrome = {};
};

MyphraseCCSLChrome.BrowserOverlay = {
  prefs: null,
  popupNode: null,
  
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("myphrase-strings");
    this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService)
                .getBranch("extensions.myphrase.");

    var menu = document.getElementById("contentAreaContextMenu");
    menu.addEventListener("popupshowing", MyphraseCCSLChrome.BrowserOverlay.showHide, false);
	
	// check if dictionary file pref is empty, if empty use a default dictionary
	// NOTE: Maybe prompt the user for a default dictionary on first run?
	var pathToDictionary = this.prefs.getCharPref("pathToDict");
	if (pathToDictionary == "") {	
		this.prefs.setCharPref("pathToDict", MyphraseCCSL.Common.chromeToPath("chrome://myphrase/content/dictionaries/hg-wells_dictionary.txt"));
	}	
  },

  showHide: function() {
    // show or hide the menuitem based on what the context menu is on
    // see http://kb.mozillazine.org/Adding_items_to_menus
    // also http://developer.mozilla.org/en/docs/XUL:PopupGuide:Extensions

    if (gContextMenu)
    {
      MyphraseCCSLChrome.BrowserOverlay.popupNode = document.popupNode; // must be saved for FF4

      document.getElementById("context-myphrase-sitePwd").hidden = 
	     document.popupNode ? ((document.popupNode.localName.toLowerCase() != "input") 
	     || (document.popupNode.type.toLowerCase() != "password")) : true;
    }
  },
  
  OpenSiteDia: function(event) {
	var obj = gContextMenu.target;

	if(obj && obj.type.toLowerCase() == "password") 
	{
		window.openDialog('chrome://myphrase/content/getMaster.xul', 
		'Myphrase Site Password Generator', 'chrome,resizable,centerscreen', obj);
	}
  },

  GetFileContent: function (aFileURL, fileSize) {
  // https://developer.mozilla.org/en/Code_snippets/File_I%2f%2fO#Binary_File

	var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);
	var url = ios.newURI(aFileURL, null, null);

	if (!url || !url.schemeIs("file")) 
		throw "Expected a file URL.";

	var bFile = url.QueryInterface(Components.interfaces.nsIFileURL).file;
	var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                          .createInstance(Components.interfaces.nsIFileInputStream);

	istream.init(bFile, -1, -1, false);

	var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
                          .createInstance(Components.interfaces.nsIBinaryInputStream);
	
	bstream.setInputStream(istream);

	var bytes = bstream.readBytes(bstream.available());
	return bytes;
  },

};
window.addEventListener("load", function(e) { MyphraseCCSLChrome.BrowserOverlay.onLoad(e); }, false);
